// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import {app, storage} from "@/firebase";
import {getFirestore, collection, getDocs, getDoc, doc, deleteDoc, setDoc} from "firebase/firestore";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Group} from "@/interfaces/user";
import {Payment} from "@/interfaces/paypal";
import {deleteObject, ref} from "firebase/storage";

const db = getFirestore(app);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method === "GET") return await get(req, res);
	if (req.method === "DELETE") return await del(req, res);
	if (req.method === "PATCH") return await patch(req, res);

	res.status(404).json(undefined);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const snapshot = await getDoc(doc(db, "payments", id));

	if (snapshot.exists()) {
		res.status(200).json({...snapshot.data(), id: snapshot.id});
	} else {
		res.status(404).json(undefined);
	}
}

async function del(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const snapshot = await getDoc(doc(db, "payments", id));
	const data = snapshot.data() as Payment;

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		if (data.commissionTransfer) await deleteObject(ref(storage, data.commissionTransfer));
		if (data.corporateTransfer) await deleteObject(ref(storage, data.corporateTransfer));

		await deleteDoc(snapshot.ref);
		res.status(200).json({ok: true});
		return;
	}

	res.status(403).json({ok: false});
}

async function patch(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};
	const snapshot = await getDoc(doc(db, "payments", id));

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		await setDoc(snapshot.ref, req.body, {merge: true});

		if (req.body.isPaid) {
			const corporateID = req.body.corporate;
			await setDoc(doc(db, "users", corporateID), {status: "active"}, {merge: true});
		}
		return res.status(200).json({ok: true});
	}

	res.status(403).json({ok: false});
}
